#!/usr/bin/env python
"""
MIRAR: https://github.com/hardbyte/python-can/blob/main/examples/asyncio_demo.py
pi@raspberrypi:~/codis/canbus $ sudo ip link set can0 type can bitrate 100000
pi@raspberrypi:~/codis/canbus $ sudo ifconfig can0 up
pi@raspberrypi:~/codis/canbus $ sudo ifconfig can0 down

"""
import os
import can
from datetime import datetime
from time import sleep
import RPi.GPIO as GPIO

LED_W = 12
LED_B = 13
TIMEOUT_RCV = 0.5
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
GPIO.setup(LED_W,GPIO.OUT)
GPIO.setup(LED_B,GPIO.OUT)

def decodeAddr(addr):
    if   addr == '0000':
        i2cAddr = 0x0
    elif addr == '0001':
        i2cAddr = 0x1
    elif addr == '0010':
        i2cAddr = 0x2
    elif addr == '0011':
        i2cAddr = 0x3
    elif addr == '0100':
        i2cAddr = 0x4
    elif addr == '0101':
        i2cAddr = 0x5
    elif addr == '0110':
        i2cAddr = 0x6
    elif addr == '0111':
        i2cAddr = 0x7
    elif addr == '1000':
        i2cAddr = 0x8
    elif addr == '1001':
        i2cAddr = 0x9
    elif addr == '1010':
        i2cAddr = 0xA
    elif addr == '1011':
        i2cAddr = 0xB
    elif addr == '1100':
        i2cAddr = 0xC
    elif addr == '1101':
        i2cAddr = 0xD
    elif addr == '1110':
        i2cAddr = 0xE
    elif addr == '1111':
        i2cAddr = 0xF
    return   i2cAddr  

"""
def req_vehicle_speed() -> can.Message:
    req_data = REQ_PAD
    req_data[0] = 0x02  # DLC = 2
    req_data[1] = 0x01  # MOD = 1
    req_data[2] = VEH_SPD_PID  # Vehicle Speed (PID = 0x0D)
    return can.Message(
        arbitration_id=REQ_ID,
        data=req_data,
        is_extended_id=False,
        dlc=8,
        timestamp=datetime.timestamp(datetime.now()),
    )

def rsp_vehicle_speed(vehicle_speed) -> can.Message:
    rsp_data = RSP_PAD
    rsp_data[0] = 0x03  # DLC = 3
    rsp_data[1] = 0x41  # MOD = 1 + Positive Response = 0x40
    rsp_data[2] = VEH_SPD_PID  # Vehicle Speed (PID = 0x0D)
    rsp_data[3] = vehicle_speed  # Vehicle Speed (0-255 kph)
    return can.Message(
        arbitration_id=RSP_ID,
        data=rsp_data,
        is_extended_id=False,
        dlc=8,
        timestamp=datetime.timestamp(datetime.now()),
    )

bus.send(rsp_vehicle_speed(veh_spd))
"""

def doutMsg(addr,side,value) -> can.Message:
    # i2cAddr = decodeAddr(addr)
    i2cAddr = int(addr,2)
    msg = []
    msg.append(2 if side.lower() == 'a' else 18)
    msg.append(value)
    print(msg)
    return can.Message(
        arbitration_id = 800 + i2cAddr,
        data = msg,
        is_extended_id = False,
        is_remote_frame = False,
        dlc = 2,
        timestamp = datetime.timestamp(datetime.now())
    )

def dversionMsg(addr) -> can.Message:
    i2cAddr = int(addr,2)
    msg = []
    return can.Message(
        arbitration_id = 800 + i2cAddr,
        data = msg,
        is_extended_id = False,
        is_remote_frame = True,
        dlc = 0,
        timestamp = datetime.timestamp(datetime.now())
    )

def send_can(msg):
    GPIO.output(LED_W,GPIO.HIGH)
    bus.send(msg)
    GPIO.output(LED_W,GPIO.LOW)

def recv_can():
    GPIO.output(LED_B,GPIO.HIGH)
    msg = bus.recv(TIMEOUT_RCV)
    GPIO.output(LED_B,GPIO.LOW)
    return msg
   
def dout(addr,side,value):
    send_can(doutMsg(addr,side,value))

# def SomeListener(msg: can.Message) -> None:
#     global listener
#     print(msg)
#     listener.stop()

def dversion(addr):
    # global listener

    # listener = SomeListener
    send_can(dversionMsg(addr))
    msg = bus.recv(.5)
    print(msg)
    if msg is not None:
        print(msg.data)
        print("Rib cfg: %d, version: %d.%d"%(msg.data[0],msg.data[1],msg.data[2]))
    else:
        print("No CAN answer in %.2f seconds"%TIMEOUT_RCV)
    # listener.on_message_received(msg)

# # os.system('sudo ip link set can0 type can bitrate 100000')
# # os.system('sudo ifconfig can0 up') # Enable can0 
# os.system('sudo ip link set up can0 type can bitrate 100000')
try:
    bus = can.interface.Bus(channel = 'can0', bustype = 'socketcan')

    GPIO.output(LED_B,GPIO.HIGH)
    sleep(0.5)
    GPIO.output(LED_B,GPIO.LOW)
    sleep(0.5)
    dversion('0000')
    sleep(0.5)

    dout('0000','A',0xFF)
    print("0xFF")
    sleep(0.5)
    dout('0000','A',0xA5)
    print("0xA5")
    sleep(0.5)
    dout('0000','A',0x5A)
    print("0x5A")
    sleep(0.5)
    dout('0000','A',0x00)
    print("0x00")
    sleep(0.5)
    # while True:
    #     dout('0000','A',0xFF)
    #     print("0xFF")
    #     sleep(0.5)
    #     dout('0000','A',0xA5)
    #     print("0xA5")
    #     sleep(0.5)
    #     dout('0000','A',0x5A)
    #     print("0x5A")
    #     sleep(0.5)
    #     dout('0000','A',0x00)
    #     print("0x00")
    #     sleep(0.5)
    #     """message = bus.recv(10.0)
    #     print (message)        
    #     if message is None:
    #         print('Timeout occurred, no message received.')"""
except KeyboardInterrupt:
    dout('0000','A',0x00)
    print("0x00")
    sleep(0.1)
    # os.system('sudo ifconfig can0 down')  #Disable can0

