#!/usr/bin/python3
#
# simple_rx_test.py
#
# https://raw.githubusercontent.com/skpang/PiCAN-Python-examples/master/simple_rx_test.py
# 
# This is simple CAN receive python program. All messages received are printed out on screen.
# For use with PiCAN boards on the Raspberry Pi
# http://skpang.co.uk/catalog/pican2-canbus-board-for-raspberry-pi-2-p-1475.html
#
# Make sure Python-CAN is installed first http://skpang.co.uk/blog/archives/1220
#
# 01-02-16 SK Pang
#
#
# Modified by Jordi Binefa - 20240621

import can
import time
import os


print('\n\rCAN Rx test')
print('Bring up CAN0....')
# os.system("sudo /sbin/ip link set can0 up type can bitrate 100000")
time.sleep(0.1)	

try:
	bus = can.interface.Bus(channel='can0', bustype='socketcan_native')
except OSError:
	print('Cannot find PiCAN board.')
	exit()
	
print('Ready')

try:
	while True:
		message = bus.recv()	# Wait until a message is received.
		
		c = '{0:f} {1:x} {2:x} '.format(message.timestamp, message.arbitration_id, message.dlc)
		s=''
		for i in range(message.dlc ):
			s +=  '{0:x} '.format(message.data[i])
			
		print(' {}'.format(c+s))
	
	
except KeyboardInterrupt:
	#Catch keyboard interrupt
	# os.system("sudo /sbin/ip link set can0 down")
	print('\n\rKeyboard interrtupt')	

