import time
import RPi.GPIO as GPIO
import socket
import sys

def sendTCP(ip,port,msg):
    # Create a TCP/IP socket
    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    # Connect the socket to the port where the server is listening
    server_address = (ip, port)
    print('connecting to {} port {}'.format(*server_address))
    try:
        sock.connect(server_address)
    except:
        print('connection failed to {} port {}'.format(*server_address))
        return

    try:
        # Send data
        # msg = b"%c%c%c%c%c"%(250,1,1,1,0)
        print('sending {!r}'.format(msg))
        sock.sendall(msg)
    finally:
        print('closing socket')
        sock.close()    


GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

bt04 = 4
bt27 = 27

GPIO.setup(bt04, GPIO.IN, GPIO.PUD_UP)
GPIO.setup(bt27, GPIO.IN, GPIO.PUD_UP)

prevBt04 = GPIO.HIGH
prevBt27 = GPIO.HIGH

while True:
    button_state_04 = GPIO.input(bt04)
    button_state_27 = GPIO.input(bt27)
    if button_state_04 != prevBt04:
        prevBt04 = button_state_04
        if button_state_04 == GPIO.LOW:
            print ("bt04 pressed")
            message = b"%c%c%c%c%c"%(250,1,1,1,0)
            sendTCP('192.168.1.112',2002,message)
    if button_state_27 != prevBt27:
        prevBt27 = button_state_27
        if button_state_27 == GPIO.LOW:
            print ("bt27 pressed")
            message = b"%c%c%c%c%c"%(250,1,1,0,0)
            sendTCP('192.168.1.112',2002,message)

    time.sleep(0.1)
